<?php

namespace Ulmus\Query;

class Offset extends Fragment {
    
    const SQL_TOKEN = "OFFSET";
    
    public int $order = 95;

    public int $offset = 0;
    
    public string $rows = "";

    public function set(int $offset) : self
    {
        $this->offset = $offset;
        
        return $this;
    }

    public function render() : string
    {
        if ( $this->offset < 0 ) {
            throw new \Exception("An error occured trying to render the OFFSET fragment ; given value has to be > 0. Received {$this->offset}");
        }
        
        return $this->renderSegments([
            static::SQL_TOKEN, $this->offset, $this->rows
        ]);
    }
}
